const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_identities = sequelize.define(
    'user_identities',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

external_subject: {
        type: DataTypes.TEXT,
      
      

      },

external_email: {
        type: DataTypes.TEXT,
      
      

      },

display_name: {
        type: DataTypes.TEXT,
      
      

      },

linked_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_identities.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity























































//end loop



    db.user_identities.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.user_identities.belongsTo(db.identity_providers, {
      as: 'identity_provider',
      foreignKey: {
        name: 'identity_providerId',
      },
      constraints: false,
    });

    db.user_identities.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.user_identities.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_identities.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_identities;
};


